cordova.define("com-itx-appstate.AppState", function(require, exports, module) {
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var cordova = require('cordova'),
    exec = require('cordova/exec'),
    utils = require('cordova/utils');

var AppState = function () {
    function AppState() {
        _classCallCheck(this, AppState);

        this.pluginName = "AppState";
    }

    _createClass(AppState, [{
        key: 'callPlugin',
        value: function callPlugin(method, success, error) {
            var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

            if (cordova.platformId.toLowerCase() == 'android' || cordova.platformId.toLowerCase() == 'ios') {
                exec(success, error, this.pluginName, method, params);
            } else {
                console.info('Ignoring due to unsuported Platform');
                error(false);
            }
        }
    }, {
        key: 'getState',
        value: function getState(success, error) {
            this.callPlugin('getState', success, error);
        }
    }, {
        key: 'subscribeToAppStateChanges',
        value: function subscribeToAppStateChanges(success, error) {
            if (this.isAndroid()) {
                success(true);

                return undefined;
            } else {
                var id = utils.createUUID();

                this.callPlugin('subscribeToAppStateChanges', success, error, [id]);

                return id;
            }
        }
    }, {
        key: 'unsubscribeFromAppStateChanges',
        value: function unsubscribeFromAppStateChanges(success, error, handlerId) {
            if (this.isAndroid()) {
                success();
            } else {
                this.callPlugin('unsubscribeFromAppStateChanges', success, error, [handlerId]);
            }
        }
    }, {
        key: 'isAndroid',
        value: function isAndroid() {
            return cordova.platformId.toLowerCase() === 'android';
        }
    }]);

    return AppState;
}();

module.exports = new AppState();
});
