cordova.define("com-itx-backgroundsync.BackgroundSyncStorage", function(require, exports, module) {
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BackgroundSyncStorage = function () {
    function BackgroundSyncStorage() {
        _classCallCheck(this, BackgroundSyncStorage);

        this.pluginName = "BackgroundSync";
        this.prefix = 'storage';
    }

    _createClass(BackgroundSyncStorage, [{
        key: "callPlugin",
        value: function callPlugin(method) {
            var _this = this;

            var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

            return new Promise(function (resolve, reject) {
                var methodName = _this.prefix + "_" + method;
                cordova.exec(resolve, function (error) {
                    return reject(_this.handleRejection(error, methodName));
                }, _this.pluginName, methodName, params);
            });
        }
    }, {
        key: "listen",
        value: function listen(callback) {
            cordova.exec(callback, callback, this.pluginName, this.prefix + "_listen", []);
        }
    }, {
        key: "handleRejection",
        value: function handleRejection(error, method) {
            return {
                plugin: this.pluginName,
                method: method,
                code: error,
                message: this.errors[error]
            };
        }
    }, {
        key: "add",
        value: function add(data) {
            return this.callPlugin("add", [data]);
        }
    }, {
        key: "remove",
        value: function remove(punchID) {
            return this.callPlugin("remove", [punchID]);
        }
    }, {
        key: "removeAll",
        value: function removeAll() {
            return this.callPlugin("removeAll", []);
        }
    }, {
        key: "reset",
        value: function reset(punchID) {
            return this.callPlugin("reset", [punchID]);
        }
    }, {
        key: "resetAll",
        value: function resetAll(type) {
            return this.callPlugin("resetAll", [type]);
        }
    }, {
        key: "query",
        value: function query(punchID) {
            return this.callPlugin("query", [punchID]);
        }
    }, {
        key: "getAll",
        value: function getAll() {
            return this.callPlugin("getAll", []);
        }
    }, {
        key: "errors",
        get: function get() {
            return {
                error: 'Storage error',
                invalid_object: 'Invalid punch object',
                1: 'Process status is true',
                2: 'Storage operation failed to send results'
            };
        }
    }]);

    return BackgroundSyncStorage;
}();

module.exports = new BackgroundSyncStorage();
});
