cordova.define("com-itx-geolocation.GeolocationPlugin", function(require, exports, module) {
"use strict";

function _instanceof(left, right) { if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) { return right[Symbol.hasInstance](left); } else { return left instanceof right; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!_instanceof(instance, Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var exec = require('cordova/exec');

var cordova = require('cordova');

var utils = require('cordova/utils');

var GeolocationPlugin =
/*#__PURE__*/
function () {
  function GeolocationPlugin() {
    _classCallCheck(this, GeolocationPlugin);
  }

  _createClass(GeolocationPlugin, [{
    key: "callPlugin",
    value: async function callPlugin(method) {
      var _this = this;

      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var callback = arguments.length > 2 ? arguments[2] : undefined;
      var promise = new Promise(function (resolve, reject) {
        exec(resolve, function (error) {
          return reject(_this.handleError(error, method));
        }, GeolocationPlugin.name, method, params);
      });

      if (callback) {
        try {
          var res = await promise;
          callback(false, res);
        } catch (e) {
          callback(true, e);
        }
      } else {
        return promise;
      }
    }
  }, {
    key: "askForPermissions",
    value: function askForPermissions(successCallback, errorCallback) {
      exec(successCallback, function onError(error) {
        if (errorCallback) {
          errorCallback(this.handleError(error, 'askForPermissions'));
        }
      }.bind(this), GeolocationPlugin.name, 'askForPermissions', []);
    }
  }, {
    key: "enable",
    value: function enable(success, error) {
      return this.callPlugin('enableLocation', [], function (err, res) {
        if (err) {
          error(res);
        } else {
          success(res);
        }
      });
    }
  }, {
    key: "getCurrentPosition",
    value: function getCurrentPosition(success, error, options) {
      return this.callPlugin('getCurrentPosition', [options], function (err, res) {
        if (err) {
          error(res);
        } else {
          success(res);
        }
      });
    }
  }, {
    key: "watchPosition",
    value: function watchPosition(success, error, options) {
      // This method cannot use async code because the success and error callbacks
      // are being saved in memory by native and both need to be passed directly.
      exec(success, error, GeolocationPlugin.name, "watchPosition", [options]);
    }
  }, {
    key: "clearWatch",
    value: function clearWatch(success, error) {
      return this.callPlugin('clearWatch', [], function (err, res) {
        if (err) {
          error(res);
        } else {
          success(res);
        }
      });
    }
  }, {
    key: "getStatus",
    value: function getStatus(callback) {
      var _this2 = this;

      return this.callPlugin('getStatus', [], function (err, res) {
        if (err) {
          callback(_this2.constants.status.NONE);
        } else {
          callback(res);
        }
      });
    }
  }, {
    key: "subscribeToPreciseLocationChanges",
    value: function subscribeToPreciseLocationChanges(success, errorCb) {
      if (this.isAndroid()) {
        success(true);
        return undefined;
      } else {
        var id = utils.createUUID();
        exec(success, function onError(error) {
          errorCb(this.handleError(error, 'subscribeToPreciseLocationChanges'));
        }.bind(this), GeolocationPlugin.name, 'subscribeToPreciseLocationChanges', [id]);
        return id;
      }
    }
  }, {
    key: "unsubscribeToPreciseLocationChanges",
    value: function unsubscribeToPreciseLocationChanges(success, errorCb, handlerId) {
      if (this.isAndroid()) {
        success();
      } else {
        exec(success, function onError(error) {
          errorCb(this.handleError(error, 'unsubscribeToPreciseLocationChanges'));
        }.bind(this), GeolocationPlugin.name, 'unsubscribeToPreciseLocationChanges', [handlerId]);
      }
    }
  }, {
    key: "isAndroid",
    value: function isAndroid() {
      return cordova.platformId.toLowerCase() === 'android';
    }
  }, {
    key: "handleError",
    value: function handleError(error, method) {
      var errorInfo = {
        plugin: GeolocationPlugin.name,
        method: method
      };

      if (error.message) {
        return _objectSpread({}, errorInfo, error);
      }

      return _objectSpread({}, errorInfo, {
        code: -1,
        message: error
      });
    }
  }, {
    key: "constants",
    get: function get() {
      return {
        errors: {
          UNAUTHORIZED: 'unauthorized',
          NO_PROVIDER: 'no provider',
          UNAVAILABLE: 'unavailable',
          ERROR: 'error'
        },
        status: {
          GPS: 'gps',
          NETWORK: 'network',
          NONE: 'none'
        }
      };
    }
  }]);

  return GeolocationPlugin;
}();

module.exports = new GeolocationPlugin();
});
