cordova.define("com-itx-permissions.PermissionsPlugin", function(require, exports, module) {
"use strict";

function _instanceof(left, right) { if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) { return right[Symbol.hasInstance](left); } else { return left instanceof right; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!_instanceof(instance, Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var exec = require('cordova/exec'),
    cordova = require('cordova');

var callPlugin = async function callPlugin(method) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var callback = arguments.length > 2 ? arguments[2] : undefined;
  var map = arguments.length > 3 ? arguments[3] : undefined;

  var customHandler = function customHandler(err) {
    return {
      code: err,
      message: map[err]
    };
  };

  var promise = new Promise(function (resolve, reject) {
    exec(resolve, function (error) {
      return reject(customHandler(error));
    }, PermissionsPlugin.name, method, params);
  });

  if (callback) {
    try {
      var res = await promise;
      callback(false, res);
    } catch (e) {
      callback(true, e);
    }
  } else {
    return promise;
  }
};

var errors = {
  0: 'Service not found'
};

var PermissionsPlugin =
/*#__PURE__*/
function () {
  function PermissionsPlugin() {
    _classCallCheck(this, PermissionsPlugin);

    this.hasPermission = this.permissionStatusForService;
  }

  _createClass(PermissionsPlugin, [{
    key: "handleError",
    value: function handleError(err) {
      return {
        code: err,
        message: this.errors[err]
      };
    }
  }, {
    key: "getNotificationAuthorizationStatus",
    value: function getNotificationAuthorizationStatus(callback) {
      var action = cordova.platformId.toLowerCase() === 'android' ? 'hasPermission' : 'getNotificationAuthorizationStatus';
      return callPlugin(action, [this.constants.NOTIFICATIONS], function (err, result) {
        if (!err) {
          callback(result);
        } else {
          callback(_objectSpread({
            service: this.constants.NOTIFICATIONS
          }, result));
        }
      }, errors);
    }
  }, {
    key: "permissionStatusForService",
    value: function permissionStatusForService(service, callback) {
      var _this = this;

      return callPlugin('hasPermission', [service], function (err, result) {
        if (!err) {
          callback(result);
        } else {
          callback(_objectSpread({
            service: service,
            status: _this.constants.status.DISABLED
          }, result));
        }
      }, errors);
    }
  }, {
    key: "openSettings",
    value: function openSettings(service, callback) {
      return callPlugin('openSettings', [service], function (err, result) {
        if (!err) {
          callback(result);
        } else {
          callback(_objectSpread({
            service: service
          }, result));
        }
      }, errors);
    }
  }, {
    key: "requestNotificationPermissions",
    value: function requestNotificationPermissions() {
      return callPlugin('requestNotificationPermissions', [], function (err, result) {// We don't expect a result, we just ask for permissions.
      }, errors);
    }
  }, {
    key: "constants",
    get: function get() {
      return {
        NOTIFICATIONS: 'notifications',
        LOCATION: 'location',
        CALENDAR: 'calendar',
        status: {
          GRANTED: 'granted',
          BLOCKED: 'blocked',
          ASK: 'ask',
          DISABLED: 'disabled',
          FULL_ACCURACY_OFF: 'full_accuracy_off'
        }
      };
    }
  }]);

  return PermissionsPlugin;
}();

module.exports = new PermissionsPlugin();
});
