cordova.define("com-itx-storage.NativeStorage", function(require, exports, module) {
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var exec = require('cordova/exec');

function isBrowser() {
    return window.cordova && (window.cordova.platformId === 'browser' || window.cordova.platformId === 'osx') || !(window.phonegap || window.cordova);
}

var NativeStorage = function () {
    function NativeStorage() {
        _classCallCheck(this, NativeStorage);
    }

    _createClass(NativeStorage, [{
        key: 'callPlugin',
        value: function callPlugin(method) {
            var _this = this;

            var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

            return new Promise(function (resolve, reject) {
                if (isBrowser()) {
                    if (method == 'set') {
                        localStorage.setItem(params[0], params[1]);
                        resolve();
                    } else if (method == 'get') {
                        resolve(localStorage.getItem(params[0]));
                    } else if (method == 'remove') {
                        localStorage.removeItem(params[0]);
                        resolve();
                    } else if (method == 'clear') {
                        localStorage.clear();
                        resolve();
                    } else if (method == 'keys') {
                        resolve(localStorage.keys());
                    }
                } else {
                    exec(resolve, function (error) {
                        return reject(_this.handleRejection(error, method));
                    }, NativeStorage.name, '' + method, params);
                }
            });
        }
    }, {
        key: 'set',
        value: function set(key) {
            var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
            var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : { secure: false };

            return this.callPlugin("set", [key, data, options]);
        }
    }, {
        key: 'get',
        value: function get(key) {
            var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { secure: false };

            return this.callPlugin("get", [key, options]);
        }
    }, {
        key: 'remove',
        value: function remove(key) {
            var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { secure: false };

            return this.callPlugin("remove", [key, options]);
        }
    }, {
        key: 'clear',
        value: function clear() {
            return this.callPlugin("clear", []);
        }
    }, {
        key: 'keys',
        value: function keys() {
            return this.callPlugin("keys", []);
        }
    }, {
        key: 'listen',
        value: function listen(callback) {
            var _this2 = this;

            if (!isBrowser()) {
                return exec(callback, function (error) {
                    return callback(_this2.handleRejection(error, 'listen'), true);
                }, NativeStorage.name, 'listen', []);
            }
        }
    }, {
        key: 'handleRejection',
        value: function handleRejection(error, method) {
            return {
                plugin: NativeStorage.name,
                method: method,
                code: error,
                message: this.errors[error]
            };
        }
    }, {
        key: 'errors',
        get: function get() {
            return {
                1: 'OPERATION FAILED',
                2: 'INVALID KEY'
            };
        }
    }]);

    return NativeStorage;
}();

module.exports = new NativeStorage();
});
