cordova.define("com-itx-utils.PaychexUtilsPlugin", function(require, exports, module) {
"use strict";

function _instanceof(left, right) { if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) { return right[Symbol.hasInstance](left); } else { return left instanceof right; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!_instanceof(instance, Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var exec = require('cordova/exec');

var PaychexUtilsPlugin =
/*#__PURE__*/
function () {
  function PaychexUtilsPlugin() {
    _classCallCheck(this, PaychexUtilsPlugin);
  }

  _createClass(PaychexUtilsPlugin, [{
    key: "callPlugin",
    value: async function callPlugin(method) {
      var _this = this;

      var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var callback = arguments.length > 2 ? arguments[2] : undefined;

      if (cordova.platformId == 'android') {
        var promise = new Promise(function (resolve, reject) {
          exec(resolve, function (error) {
            return reject(_this.handleError(error, method));
          }, PaychexUtilsPlugin.name, method, params);
        });

        if (callback) {
          try {
            var res = await promise;
            callback(false, res);
          } catch (e) {
            callback(true, e);
          }
        } else {
          return promise;
        }
      } else {
        console.info('Ignoring Utils Plugins due to unsuported Platform');
      }
    }
  }, {
    key: "hideSplash",
    value: function hideSplash() {
      return this.callPlugin("hideSplash");
    }
  }, {
    key: "finish",
    value: function finish() {
      return this.callPlugin("finish");
    }
  }, {
    key: "sendToBackground",
    value: function sendToBackground() {
      return this.callPlugin("sendToBackground");
    }
  }, {
    key: "reload",
    value: function reload() {
      return this.callPlugin("reload");
    }
  }, {
    key: "enableLog",
    // Calls with parameters
    value: function enableLog(enable) {
      return this.callPlugin("enableLog", [enable]);
    }
  }, {
    key: "setWaitTime",
    value: function setWaitTime(wait_time) {
      return this.callPlugin("setWaitTime", [wait_time]);
    }
  }, {
    key: "handleError",
    value: function handleError(error, method) {
      var errorInfo = {
        plugin: PaychexUtilsPlugin.name,
        method: method
      };

      if (error.message) {
        return _objectSpread({}, errorInfo, error);
      }

      return _objectSpread({}, errorInfo, {
        code: -1,
        message: error
      });
    }
  }]);

  return PaychexUtilsPlugin;
}();

module.exports = new PaychexUtilsPlugin();
});
